﻿using Business;
using Modèle;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace WpfApp1
{
    /// <summary>
    /// Logique d'interaction pour InfoUtilisateur.xaml
    /// Page qui permet à un utilisateur de voir ses informations
    /// </summary>
    public partial class InfoUtilisateur : Window
    {

        public InfoUtilisateur()
        {
            InitializeComponent();
        }

        public ManagerUsers MgrUser => (Application.Current as App).LeManagerUsers; //Manager lié à celui de l'app

        private Personne _pers;
        public Personne pers    //L'utilisateur qui permettra de mettre les informations de la page à jour
        {
            get { return _pers; }
            set
            {
                _pers = value;
                UpdateUi(_pers);
            }
        }

        /// <summary>
        /// Méthode qui permet de mettre à jour les informations de la page
        /// </summary>
        /// <param name="pers"></param>
        private void UpdateUi(Personne pers)
        {
            mdp.Text = "";
            email.Text = pers.Email;
            for (int i = 0; i < pers.MotDePasse.Length; i++)
            {
                mdp.Text = mdp.Text + "*";
            }
            if (MgrUser.SelectedUser is Utilisateur user)
            {
                surnombre.Text = user.NbSubmit.ToString();
            }
            else if (MgrUser.SelectedUser is Expert alex)
            {
                mess.Text = "Surnom";
                surnombre.Text = alex.Surnom;
            }
        }


        /// <summary>
        /// Evénement qui permet de quitter la page
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void exit_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }


        /// <summary>
        /// Evénement qui permet à l'utilisateur de se déconnecter
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void deco_Click(object sender, RoutedEventArgs e)
        {
            Close();
            MgrUser.SelectedUser = null;
        }


        /// <summary>
        /// Evénement qui permet d'ouvrir la page ChangerMotDePasse
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void changer_Click(object sender, RoutedEventArgs e)
        {
            var changerWindow = new ChangerMotDePasse();
            changerWindow.ShowDialog();
        }
    }
}
