﻿using Business;
using Modèle;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using VideoLibrary;


namespace WpfApp1
{
    /// <summary>
    /// Logique d'interaction pour userControlDescription.xaml
    /// </summary>
    public partial class userControlDescription : UserControl
    {
        public userControlDescription()
        {
            InitializeComponent();
        }
        public ManagerUsers MgrUser => (Application.Current as App).LeManagerUsers;
        public Manager Mgr => (Application.Current as App).LeManager;

        private Requin _requin;
        public Requin requin
        {
            get { return _requin; }
            set
            {
                _requin = value;
                UptadeUi(_requin);
            }
        }

        public int cmp = 0;

        private void exit_Click(object sender, RoutedEventArgs e)
        {
            ((MainWindow)System.Windows.Application.Current.MainWindow).ContentControlSwapAcc();
        }

        private void edit_Click(object sender, RoutedEventArgs e)
        {
            if (MgrUser.SelectedUser == null)
            {
                MessageBox.Show("Vous avez besoin d'être connecté pour accéder à cette fonctionnalité");
                var seConnecter = new SeConnecter();
                seConnecter.ShowDialog();
            }
            else
            {
                ((MainWindow)System.Windows.Application.Current.MainWindow).ContentControlSwapEdit(requin);
            }
        }



        private BitmapImage urlEnBitmap(string url)
        {
            var path = @url;
            BitmapImage bitmap = new BitmapImage();
            bitmap.BeginInit();
            bitmap.UriSource = new Uri(path, UriKind.Absolute);
            bitmap.EndInit();
            return bitmap;
        }

        public void UptadeUi(Requin requin)
        {
            string url = "Images/" + requin.StatutCons.ToString() + ".png";
            nameReq.Text = requin.Nom;
            sciName.Text = requin.NomSci;
            desc.Text = requin.Description;
            
            funFact.Text = requin.FunFact;
            consPic.Source = new BitmapImage(new Uri(url, UriKind.Relative));

            //La source des vidéos ne peut pas venir d'internet ou de youtube avec plus de temps nous aurions rajouté cette fonctionnalité
            vid.Source = new Uri(requin.Video, UriKind.Relative);   

            //La source des photos peuvent venir d'internet
            if (requin.Photo.Contains("Images/"))   //Vérifie si la photo vient d'internet ou du dossier
            {
                photo.Source = new BitmapImage(new Uri(requin.Photo, UriKind.RelativeOrAbsolute));
            }
            else
            {
                BitmapImage bitmap = new BitmapImage();
                bitmap = urlEnBitmap(requin.Photo);
                photo.Source = bitmap;
            }


            if (requin.PhotoCarte.Contains("Images/"))
            {
                cartePic.Source = new BitmapImage(new Uri(requin.PhotoCarte, UriKind.RelativeOrAbsolute));
            }
            else
            {
                BitmapImage bitmap = new BitmapImage();
                bitmap = urlEnBitmap(requin.PhotoCarte);
                cartePic.Source = bitmap;
            }

        }

        private void vid_MouseDown(object sender, MouseButtonEventArgs e)
        {
            cmp = cmp+1;
            if (cmp == 10)
            {
                vid.Source = new Uri("Videos/requin_Asley.mp4", UriKind.Relative);
            }
        }
    }
}
